<template>
  <div class="main-wrapper">

    <div id="slideshow">
      <div class="slide-wrapper">
        <div class="slide" v-for="(image, index) in images" :key="index"><img alt="housePic" :id="index" :key="index" :src="image"/></div>
      </div>
    </div>
    
      <h2> {{ address }} </h2>

      <p id="description"> {{ description }} </p>

      <ul>
        <li>
          <p> <b>Latitude:</b> {{ latitude }} </p>
        </li>
        <li>
            <p> <b>Longitude:</b> {{ longitude }} </p>    
        </li>
      </ul>

      <div id="agent">
        <img id="profilePic" :src="require(`@/assets/profilePics/${agentImg}`)" alt="profilePic">
        <p> {{ agentName }} </p>
        <p> {{ agentEmail }} </p>
        <p> {{ agentPhoneNumber }} </p>
      </div>
  </div>
</template>

<script>
// Importing Data object for handling of getting listings and agents
import Data from '../global/variable.js';
export default {
  name: 'House',
  props: {
    // Props are set from the view HouseInfo.vue
    houseId: String,
    agentId: String,
  },
  data() {
    return {
        // Setting default data to be shown if something went wrong with the information fetching
        address: "123 Texas Street",
        description: "Yeehaaw! This is a cowboy estate for some reason. If you see this listing, something went wrong.",
        latitude: 15,
        longitude: 15,
        images: [
            "https://thisrentaldoesnotexist.com/img-new/img1.jpg",
            "https://thisrentaldoesnotexist.com/img-new/img2.jpg"
        ],
        agentName: "Kalle",
        agentEmail: "kallelofquist@hotmail.com",
        agentPhoneNumber: 733218435,
        agentImg: "1.jpg"
    }
  },
  mounted() {
    // Fetching data from Data in variable.js
    const listing = Data.getListing(this.agentId, this.houseId);
    const agent = Data.getAgent(this.agentId);

    // Information regarding the estate
    this.address = listing.address;
    this.description = listing.description;
    this.latitude = listing.latitude;
    this.longitude = listing.longitude;
    this.images = listing.images;

    // Information regarding the associated agent
    this.agentName = agent.first_name + ' ' + agent.last_name;
    this.agentEmail = agent.email;
    this.agentPhoneNumber = agent.telephone;
    this.agentImg = agent.profile_image;

  }
}
</script>

<style scoped lang="scss">

    /*
    * Mixin for regulating slideshow based on number of images
    * TODO: Fix dynamic mixin based on input;
    */
    @mixin slideshowModerator($size) {

      /*@if $size == 1 {
        20% {margin-left: 0px;}
      } @else if $size == 2 {
        20% {margin-left: 0px;}
        30% {margin-left: -276px;}
        50% {margin-left: -276px;}
      } @else if $size == 3 {
        20% {margin-left: 0px;}
        30% {margin-left: -276px;}
        50% {margin-left: -276px;}
        60% {margin-left: -552px;}
        70% {margin-left: -552px;}
      }*/ @if $size == 4 {
        20% {margin-left: 0px;}
        30% {margin-left: -276px;}
        50% {margin-left: -276px;}
        60% {margin-left: -552px;}
        70% {margin-left: -552px;}
        80% {margin-left: -828px;}
        90% {margin-left: -828px;}
      } @else {
        @error "Unknown size #{$size}.";
      }
    }

  /*
  * Style for everything inside div in template
  */
  .main-wrapper {

    text-align: center;

    h2 {
        font-style: italic;
    }

    #description {
        display: inline-flex;
        color: grey;
    }

    img {
      border-radius: 10px;
      margin: 0 10px;
    }

    ul {
      list-style-type: none;
      display: block;
      margin-top: 30px;
      margin-bottom: 50px;
      padding: 0;
    }

    ul li {
      margin-bottom: 20px;
    }

    #agent {
      display: block;
      margin: 0 auto;
    }

    #profilePic {
      width: 80px;
      height: 80px;
      border-radius: 80px 80px;
    }

    /*
    * Start slideshow style
    */
    #slideshow {
      overflow: hidden;
      width: 276px;
      margin: 0 auto;
    }

    .slide-wrapper {
      width: 1200px;
      -webkit-animation: slide 18s ease infinite;
    }

    .slide {
      float: left;
      width: 276px;
    }

    @keyframes slide {
      @include slideshowModerator(4);
    }
    /*
    * End slideshow style
    */
}

</style>